with Grt.Types; use Grt.Types;
with Grt.Typedesc; use Grt.Typedesc;
with Grt.Hierarchy; use Grt.Hierarchy;
with Interfaces.C_Streams; use Interfaces.C_Streams;

package Grt.Disp is
   --  Procedures to disp on STREAM.
   procedure Put (Stream : FILEs; Str : String);
   procedure Put_I32 (Stream : FILEs; I32 : Ghdl_I32);

   --  And on stdout.
   procedure Put (Str : String);
   procedure Put (C : Character);
   procedure New_Line;
   procedure Put_Line (Str : String);

   --  Put STR using put procedures.
   procedure Put_Str_Len (Stream : FILEs; Str : Ghdl_Str_Len_Type);

   --  Display all simple signals.  Raw output.
   procedure Disp_Simple_Signals (Sources : Boolean);

   --  Disp current time and current delta.
   procedure Disp_Now;

   --  Disp a value.
   procedure Disp_Value (Stream : FILEs;
                         Value : Value_Union;
                         Type_Desc : Ghdl_Desc_Ptr);

   --  Disp design hierarchy;
   procedure Disp_Hierarchy;

   --  Disp design hierarchy.
   procedure Disp_Hierarchy_Tree;

   --  Disp signals propagation order.
   procedure Disp_Signals_Order;

   --  Disp signals type.
   procedure Disp_Signals_Type;

   --  Disp full path for instance name INST.
   procedure Disp_Instance_Name (Inst : Ghdl_Instance_Name_Acc);
end Grt.Disp;
