with System;
with Grt.Typedesc; use Grt.Typedesc;
with Grt.Types; use Grt.Types;

package Grt.Typedesc_Handling is
   --  Return the number of elements for DESC.
   function Get_Nbr_Signals (Desc : Ghdl_Desc_Ptr) return Ghdl_Index_Type;

   type Any_Constr_Type is limited private;

   procedure Create_Writer (Res : out Any_Constr_Type; Desc : Ghdl_Desc_Ptr);
   procedure Create_Writer (Res : out Any_Constr_Type;
                            Desc : Ghdl_Desc_Ptr; Length : Natural);
   procedure Create_Reader (Res : out Any_Constr_Type; Desc : Ghdl_Desc_Ptr);
   procedure Release (Constr : in out Any_Constr_Type);

   function Get_Value_Addr (Constr : Any_Constr_Type) return System.Address;

   procedure Write_Value (Constr : in out Any_Constr_Type;
                          Mode : Mode_Type;
                          Val : Value_Union);
   procedure Read_Value (Constr : in out Any_Constr_Type;
                         Mode : Mode_Type;
                         Res : out Value_Union);

   --  FIXME: add subprograms which handle arrays and record (*and* their
   --  alignment).

   procedure Write_B2 (Constr : in out Any_Constr_Type; Val : Ghdl_B2);
   procedure Write_E8 (Constr : in out Any_Constr_Type; Val : Ghdl_E8);
   procedure Write_I32 (Constr : in out Any_Constr_Type; Val : Ghdl_I32);
   procedure Write_P64 (Constr : in out Any_Constr_Type; Val : Ghdl_P64);
   procedure Write_F64 (Constr : in out Any_Constr_Type; Val : Ghdl_F64);
private
   type Any_Constr_Type is record
      Desc : Ghdl_Desc_Ptr;
      Base : System.Address;
      Ptr : System.Address;
   end record;
end Grt.Typedesc_Handling;
